
/*================================================*\

	Samedi 21 novembre 1998

	Arash HABIBI

	Application.c

	Tout ce qui concerne l'application.

\*================================================*/


#include "Application.h"


Appli_t Appli; 


int InitApplication(int identite)
/*================================================*\
  En l'occurrence ne fait rien du tout. 
\*================================================*/
{
  Appli.identite = identite; 
  
  Appli.FichAEmettre=-1;
  Appli.FichAEnregistrer=-1;
  Appli.Terminal=-1;

  Appli.nb_fichiers_recus=1;

  Appli.Terminal = open("/dev/tty", O_RDWR); 
  if(Appli.Terminal == -1) {perror("/dev/tty"); return(-1);}

  sprintf(Appli.prompt,    "HDLC%d :) ", identite);
  PrintPrompt(Appli.Terminal, Appli.prompt);

  return(Appli.Terminal);
}


void StopApplication()
/*================================================*\
   Ferme le terminal. 
\*================================================*/
{
  close(Appli.Terminal);
  printf("\n\nHDLC%d : Ciao !\n\n", Appli.identite);
}


void Help()
/*===============================================*\
   Affiche l'ensemble des commandes disponibles. 
\*===============================================*/
{
  printf("\n");
  printf("\"envoi <fichier>\" \t Transmet le fichier <fichier>.\n");
  printf("\"!<cmd> \" \t\t pour lancer une commande shell <cmd>\n");
  printf("\"help\" ou \'?\': \t\t pour l'aide.\n");
  printf("\"quit\" \t\t\t pour arreter HDLC.\n");
  printf("\n");
}

void PrintPrompt(int terminal, char *prompt)
/*================================================*\
  Ecrit le prompt. 
\*================================================*/
{
  if(write(terminal, prompt, strlen(prompt)+1)==-1)
    perror("Prompt write"); 
}


int OpenFichEmis(char *nomfich)
/*================================================*\
  Rend le descripteur du fichier a envoyer. 
\*================================================*/
{
  mode_t mode; 
  int EmitFile=-1; 

  mode = S_IRUSR|S_IWUSR; 
  
  if((EmitFile=open(nomfich, O_RDONLY, mode))==-1)
    perror(nomfich);
  else
    printf("\"%s\" -> Emission\n", nomfich);

  return(EmitFile);
}


int OpenFichRecu(int numero)
/*================================================*\
  C'est le numero-ieme fichier de reception qu'on 
  ouvre. Il s'appellera donc FichRecu<numero>
\*================================================*/
{
  char nom[20]; 
  mode_t mode; 
  int SaveFile=-1; 

  mode = S_IRUSR|S_IWUSR; 
             
  sprintf(nom, "Recu%d.hdlc%d", numero, Appli.identite);

  SaveFile=open(nom, O_WRONLY|O_CREAT|O_TRUNC, mode);

  if(SaveFile==-1)
    perror(nom);
  else
    printf("Reception -> \"%s\"\n", nom);

  return(SaveFile);
}


int OrigineApplication(void *paquet, int *taille)
/*================================================*\
   Rend le paquet que donne l'application et la 
   taille (en octets) de ce qui a ete recu. Si rien 
   n'est lu c'est simplement que le fichier est 
   termine : on retourne EMISSION_FINIE. 
   En entree taille doit avoir la valeur de l'espace
   alloue pour la reception du paquet. En sortie, 
   taille est le nombre d'octets effectivement lus. 
\*================================================*/
{
  int taille_lu; 

  taille_lu = read(Appli.FichAEmettre, 
		   paquet, 
		   *taille);

  if(taille_lu<0)
    {perror("OrigineAppli read "); return(CRASH);}
  
  else if(taille_lu==0) 
    { close(Appli.FichAEmettre);
    Appli.FichAEmettre=-1;
    printf("Emission terminee\n");
    return(EMISSION_FINIE);}
  
  else /* if(taille_lu>0) */
    {*taille = taille_lu; return(TOUT_BAIGNE);}
}


int VersApplication(void *paquet, int taille)
/*================================================*\
  Enregistre le paquet recu dans le fichier 
  FichAEnregistrer. taille s'exprime en octets. 
\*================================================*/
{
  if(Appli.FichAEnregistrer==-1)
    Appli.FichAEnregistrer = 
      OpenFichRecu(Appli.nb_fichiers_recus);

  if(Appli.FichAEnregistrer!=-1)
    if(write(Appli.FichAEnregistrer, 
	     paquet, 
	     taille)==-1)
      {perror("VersAppli write"); return(CRASH);}
  
  return(TOUT_BAIGNE);
}


void VersCmdAppli()
/*================================================*\
  Pour dire a la couche application que le fichier 
  qu'on etait en trait de recevoir de la station 
  distante a ete entierement recu. On peut donc
  le fermer et attendre le prochain. 
\*================================================*/
{
  if(Appli.FichAEnregistrer!=-1)
  {
    close(Appli.FichAEnregistrer);
    Appli.FichAEnregistrer=RIEN; 
  }

  printf("Reception terminee.\n");

  Appli.nb_fichiers_recus++;
}


int OrigineCmdAppli(int *commande, int *desc)
/*================================================*\
  La valeur de commande peut etre soit QUIT soit 
  ENVOI, soit SHELL, soit RIEN, autre chose mais 
  qui n'a rien a voir avec la couche liaison. 
  Cette fonction remplit le role de l'interface
  OSI entre application et liaison : 
  CONNECT.request, DISCONNECT.request etc. etc. 
\*================================================*/
{
  char ligne[500], nom_fich[300], cmd[20];
  int nb_lu, nb_arg; 

  nb_lu = read(Appli.Terminal, ligne, 500);

  if(nb_lu==-1) {perror("OrigineCmdAppli read"); return(CRASH);}	  
  
/*-------- RIEN -----------*/	  

  else if(nb_lu==1) *commande=RIEN; 
/*---(un return sans commande)---*/

/*-------- QUIT -----------*/	  
  
  else if(ligne[0]=='q') *commande=QUIT;

/*-------- SHELL -----------*/	  

  else if(ligne[0]=='!') {*commande=SHELL; ligne[nb_lu-1]=0; system(ligne+1);}

/*-------- HELP -----------*/	  

  else if(ligne[0]=='?') {*commande=HELP; Help();}

/*-------- LES COMMANDES A PARAMETRES -----------*/	  

  else
    {
      nb_arg = sscanf(ligne, "%s %s", cmd, nom_fich); 

      /*-------- HELP -----------*/	  

      if(strcmp(cmd, "help")==0)  { *commande = HELP;  Help(); }

      /*-------- ENVOI -----------*/	  

      if(strcmp(cmd, "envoi")==0)
	{
	  *commande = ENVOI; 
	  if(nb_arg!=2) fprintf(stderr,"Usage : envoi <nomfich>\n");
	  else 
	    {
	      if(Appli.FichAEmettre!=-1)
		{*desc=Appli.FichAEmettre;
		fprintf(stderr,
			"Emission precedente pas encore terminee.\n");}
	      else
		*desc = Appli.FichAEmettre = OpenFichEmis(nom_fich);
	    }
	}

      /*-------- AUTRES A VENIR -----------*/	  

      else
	fprintf(stderr,"%s : Commande inconnue.\n:", commande);
    }
  PrintPrompt(Appli.Terminal, Appli.prompt);  
  return(TOUT_BAIGNE);
}


