
/*================================================*\

	Samedi 21 novembre 1998

	Arash HABIBI

	main.c

	Programme HDLC
	
	HDLC 1 ou HDLC 2 : lance une station avec 
		avec l'identite 1 ou 2. L'identite 
		sert seulement a nommer les sockets
		et a appeler les fichiers recus. 
		Par defaut HDLC 1 aura sock_station1
		et HDLC 2 aura sock_station2. 

		Ensuite, les commandes possibles 
		sont "envoi <totofile>" et "quit". 
		
\*================================================*/


#include "Application.h"
#include "Liaison.h"
#include "Physique.h"
#include "CtrlC_Propre.h"



void ExitPropre()
/*================================================*\
  Pour terminer le processus en fermant fichiers, 
  terminaux et sockets. 
\*================================================*/
{ 
  StopApplication();
  StopCouchePhysique(); 
  exit(0);
}



void main(int argc, char **argv)
/*================================================*\
\*================================================*/
{ 
   int desc_term=-1; 
   int desc_sock=-1;
   int identite;		/* 0 ou 1 selon la machine */
   char nom_socket_loc[100];
   char nom_socket_dist[100];
   
   if(argc!=2)
   {
   	fprintf(stderr,"\nUsage :\tHDLC 1 ou HDLC 2\n");
	exit(1);
   }
   
   identite = atoi(argv[1]);

/*------------ ExitPropre en cas de ctrl C ------------------*/

   EnCasDeCtrl_C(&ExitPropre);

/*------------ Initialisation de l'application --------------*/
   
   desc_term = InitApplication(identite);

   if(desc_term==-1) exit(1);
   
	
/*------------ Initialisation de la couche physique ---------*/

    sprintf(nom_socket_loc,  "sock_station%d", identite);
    sprintf(nom_socket_dist, "sock_medium%d" , identite);
    
    desc_sock = InitCouchePhysique(nom_socket_loc, nom_socket_dist);
   
/*------------ Lancement de la couche liaison ---------------*/

    ExecCoucheLiaison(desc_sock, desc_term);
    
/*------------ Fermetures -----------------------------------*/

    ExitPropre();
}
