
/*===============================================*\
	Samedi 7 novembre 1998

	Arash HABIBI

	MediumToolbox.c

	Quelques fonctions accessoires pour la
	gestion du medium. 

\*================================================*/


#include "MediumToolbox.h"


int OpenTerminal()
/*================================================*\
  Rend le descripteur du terminal ou sont lus
  les commandes. 
\*================================================*/
{
  int terminal; 

  terminal = open("/dev/tty", O_RDWR); 
  if(terminal == -1) {perror("/dev/tty"); exit(1);}

  return(terminal);
}


void PrintPrompt(int terminal, char *prompt)
/*================================================*\
  Ecrit le prompt. 
\*================================================*/
{
  if(write(terminal, prompt, strlen(prompt)+1)==-1)
    perror("Prompt write"); 
}


void ShellCommand(char *param)
/*===============================================*\
  Lance la commande systeme exprimee par param. 
\*===============================================*/
{
   system(param);
}


void Help()
/*===============================================*\
   Affiche l'ensemble des commandes disponibles. 
\*===============================================*/
{
  printf("\n");
  printf("\"taux\" \t\t affiche le taux d'erreur sur le canal.\n");
  printf("\"taux <taux>\" \t change le taux d'erreur a <taux>.\n");
  printf("\"type\" \t\t affiche le type d'erreur realisee.\n");
  printf("\"type <type> \" \t change le type d'erreur a <type>.\n");
  printf("\"!<cmd> \" \t pour lancer une commande shell <cmd>\n");
  printf("\"help\" ou \'?\': \t pour l'aide.\n");
  printf("\"quit\" \t\t pour arreter le medium.\n");
  printf("\n");
}



void ChangeTaux(int nb_arg, char *param, float *taux)
/*===============================================*\
   Change la valeur de taux, si toutefois 
   celle-ci est comprise entre 0 et 1. Sinon elle
   lance un message et ne touche pas a l'ancienne
   valeur de taux. Si la longueur de param est nulle, 
   alors on ne fait qu'imprimer le taux d'erreur. 
\*===============================================*/
{
    float taux_lu; 
	
    if((nb_arg<1)||(nb_arg>2)) 
    	printf("Usage : taux <taux> ou taux\n");
    
    else if(nb_arg==1)
    	fprintf(stderr,"taux d'erreur = %f\n",*taux);
	
    else /* if(nb_arg==2) */
    	{
	sscanf(param, "%f", &taux_lu);
	if((taux_lu>=0)&&(taux_lu<=1)) 
	    {*taux = taux_lu;
	    printf("Le taux d'erreur est mise a %f\n", *taux);}
    	
    	else /* valeur fausse */
    		fprintf(stderr, 
    		"Le taux d'erreur doit etre compris entre 0 et 1.\n");
	}
}
    
   
void ChangeType(int nb_arg, char *param, int *type)
/*===============================================*\
   Change la valeur du type d'erreur, si toutefois 
   celle-ci est comprise entre 0 et NB_TYPE_ERREUR. 
   Sinon elle lance un message et ne touche pas a 
   l'ancienne valeur de type. Si la longueur de 
   param est nulle, alors on ne fait qu'imprimer 
   le type d'erreur. 
\*===============================================*/
{
    int type_lu; 
	
    if((nb_arg<1)||(nb_arg>2)) 
    	printf("Usage : type <type> ou type\n");
    
    else if(nb_arg==1)
    	fprintf(stderr,"type d'erreur = %d\n",*type);
	
    else /* if(nb_arg==2) */
    	{
	sscanf(param, "%d", &type_lu);
	if((type_lu>=0)&&(type_lu<=NB_TYPE_ERREUR)) 
	    {*type = type_lu;
	    printf("Le type d'erreur est mise a %d\n", *type);}
    	
    	else /* valeur fausse */
    		fprintf(stderr, 
    		"Le type d'erreur doit etre compris entre 0 et %d.\n",
		NB_TYPE_ERREUR);
	}
}



int LectCommande(int terminal, char *param, int *nb_arg)
/*================================================*\
   Rend TAUX, TYPE, SHELL, HELP ou QUIT, avec 
   l'argument. Rend -1 si probleme.  
\*================================================*/
{
  int nb_lu;
  char ligne[100], command[50];

  nb_lu = read(terminal, ligne, 100);
  if(nb_lu==-1)
    {perror("Appli_LectCommande read"); return(-1);}
  
  if(ligne[0]=='!') {strcpy(param, ligne+1); return(SHELL);}
  else if(ligne[0]=='?') return(HELP);
  else if(ligne[0]=='q') return(QUIT);
  else
  {
  	*nb_arg = sscanf(ligne, "%s %s", command, param);

  	if(*nb_arg>2) 
    		{printf("trop d'arguments.\n"); return(-1);}
  	else if(*nb_arg<0) return(-1);
  	else 
    	{
      	if(strcmp(command, "taux")==0)      return(TAUX);
      	else if(strcmp(command, "type")==0) return(TYPE);     
      	else if(strcmp(command, "help")==0) return(HELP);
      	else if(strcmp(command, "quit")==0) return(QUIT);
  
      	else 
		{fprintf(stderr,"Commande inconnue.\n");
		return(HELP);}
	}
    }
}

