
/*===============================================*\

	Mardi 3 novembre 1998

	Arash HABIBI

	Decodage.c

	A partir d'une chaine de donnees codees
	prepare un message en clair. 

\*================================================*/


#include "CodageDecodage.h"


void RecopieBitsDonneesDec(CarCode_t *message_code, char *message, int taille_message)
/*===============================================*\
  Recupere l'information utile contenu dans 
  message_code aux bons emplacements et les 
  place en clair dans message. 
\*===============================================*/
{
  int i; 

  for(i=0; i<taille_message; i++)
    {
      SetNiemeBitC(&(message[i]), 1,  NiemeBit(message_code[i], 5)); 
      SetNiemeBitC(&(message[i]), 2,  NiemeBit(message_code[i], 6)); 
      SetNiemeBitC(&(message[i]), 3,  NiemeBit(message_code[i], 7)); 
      SetNiemeBitC(&(message[i]), 4,  NiemeBit(message_code[i], 8)); 
      SetNiemeBitC(&(message[i]), 5,  NiemeBit(message_code[i], 9)); 
      SetNiemeBitC(&(message[i]), 6,  NiemeBit(message_code[i], 10)); 
      SetNiemeBitC(&(message[i]), 7,  NiemeBit(message_code[i], 11)); 
      SetNiemeBitC(&(message[i]), 8,  NiemeBit(message_code[i], 12));
    }
}


int IlyaErreur(CarCode_t *message_code, int taille_message)
/*===============================================*\
  Rend 1 si le test de parite echoue et 0 sinon. 
\*===============================================*/
{
  int i, YAErreur=0;
  CarCode_t reste; 
  
  for(i=0; (i<taille_message)&&(!YAErreur); i++)
    {
      TronquerANbits(&(message_code[i]), 12);

      /* Met a Zero les bits 13, 14, 15 et 16 */

      if(reste = ResteDivisionModulo2(message_code[i], GENERATEUR))
	YAErreur=1; 
    }
  return(YAErreur); 
}


void Decodage(char *message_code, int taille_msg_code, char *message, int *taille_message)
/*===============================================*\
  A partir du message code, et de sa longueur, rend
  le message en clair qu'il contient, eventuellement 
  corrige. 
\*===============================================*/
{
  int i;

  *taille_message = taille_msg_code/sizeof(CarCode_t); 
  
  RecopieBitsDonneesDec((CarCode_t*)message_code, message, *taille_message);

  if(IlyaErreur((CarCode_t*)message_code, *taille_message))
    printf("ERREUR CRC : \"%s\"\n", message);
}



