
/*===============================================*\
	Samedi 21 novembre 1998

	Arash HABIBI

	Liaison.c

\*================================================*/

#include "Liaison.h"

Liaison_t liaison[MAX_LIAISON]; 
int nb_liaisons=0; 

int LiaConnectRequest(char *adresse_loc_name, char *adresse_dist_name)
/*================================================*\
  Demande une connexion a la couche physique et 
  rend le descripteur. 
\*================================================*/
{
  if(nb_liaisons+1>=MAX_LIAISON)
    {
      printf("Le nombre maximal de liaisons : %d\n", 
	     MAX_LIAISON); return(-1);
    }
  else
    {
      (liaison[nb_liaisons]).phys_desc = 
	PhysConnectRequest(adresse_loc_name, adresse_dist_name); 
      
      if((liaison[nb_liaisons]).phys_desc<0)
	return(-1);
      else
	{
	  (liaison[nb_liaisons]).lia_desc = nb_liaisons; 
	  (liaison[nb_liaisons]).PTAE = 0;
	  (liaison[nb_liaisons]).TA   = 0;
	  (liaison[nb_liaisons]).connecte = 1;
	  printf("Couche liaison prete.\n");
	  return(nb_liaisons++);
	}
    }
}


void LiaDataRequest(int desc, char *paquet, int taille_paquet)
/*===============================================*\
\*===============================================*/
{
  char trame[MAX_TRAME];
  int taille_trame;

  if((desc<0)||(desc>nb_liaisons-1))
    {
      printf("Le descripteur de liaisons doit etre compris entre 0 et %d (et non %d)\n", 
	    0, nb_liaisons-1, desc); exit(1);
    }
  else
    {
      Codage(paquet, taille_paquet, trame, &taille_trame); 
      PhysDataRequest(desc, trame, taille_trame); 
    }
}


int LiaDataIndication(int desc, char *paquet)
/*===============================================*\
\*===============================================*/
{
  char trame[MAX_TRAME];
  int taille_trame, taille_paquet; 

  if((desc<0)||(desc>nb_liaisons-1))
    {
      printf("Le descripteur de liaisons doit etre compris entre 0 et %d (et non %d)\n", 
	    0, nb_liaisons-1, desc); return(-1);
    }
  else
    {
      if((taille_trame = PhysDataIndication(desc, trame))>0)
	{
	  Decodage(trame, taille_trame, paquet, &taille_paquet); 
	  return(taille_paquet);
	}

      else if(taille_trame == -1) return(-1);  

      else /* if(taille_trame == 0) */
	{
	  if(PhysDisconnectIndication(desc))
	    {
	      (liaison[nb_liaisons]).connecte = 0;
	      PhysDisconnectRespond(desc);
	      return(0);
	    }
	}
    }
}


void LiaDisconnectRequest(int desc)
/*================================================*\
\*================================================*/
{
  if((desc<0)||(desc>nb_liaisons-1))
    {
      printf("Le descripteur de liaison doit etre compris entre 0 et %d (et non %d)\n", 
	    0, nb_liaisons-1, desc); exit(1);
    }
  else
    {
      printf("Couche liaison : echange termine.\n");
      PhysDisconnectRequest(desc); 
    }
}


int LiaDisconnectIndication(int desc)
/*================================================*\
\*================================================*/
{
  if((desc<0)||(desc>nb_liaisons-1))
    {
      printf("Le descripteur de liaison doit etre compris entre 0 et %d (et non %d)\n", 
	    0, nb_liaisons-1, desc); return(-1);
    }
  else
    {
      if((liaison[nb_liaisons]).connecte == 0) return(1);
      else return(0);
    }
}

