
//================================================
//
//	Samedi 21 novembre 1998
//
//	Arash HABIBI
//
//	Emission.c
//
//	Se contente de lancer application et liaison
//	reserve des tubes pour la communication 
//	entre les couches. Deux tubes pour chaque
//	service. 
//
//================================================


#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "Timer.H"
#include "Liaison.H"
#include "Application.H"


void Application(char *FileName, Liaison_c *liaison)
//================================================
//================================================
{
  mode_t mode; 
  int taille; 
  char paquet[MAX_PAQUET];
  
  mode = S_IRUSR|S_IWUSR; 

  if((ReadFile=open(argv[1], O_RDONLY, mode))==-1)
    {perror(argv[1]); exit(1);}

  if(liaison->ConnectIndication())
    liaison->ConnectRespond();
  else
    {
      liaison->ConnectRequest();
      timer->Start();

      liaison->WaitForConnectConfirm
      while((!liaison->ConnectConfirm())&&
	    (!timer->Expired()));

      if(timer->Expired())
	{fprintf(stderr,
		 "Application : connexion refusee par l'entite distante.\n"); 
	exit(1);}
      else
	{
	  while((taille = read(ReadFile, paquet, MAX_PAQUET))>0)
	    liaison->DataRequest(paquet, taille);
  
	  if(taille<0)
	    {perror("read file"); exit(1);}
	  else
	    {
	      printf("Appli : Emission terminee.\n");
	      liaison->DisconnectRequest();
	      //jusqu'a liaison->DisconnectConfirm();
	      close(ReadFile);
	    }
	}
    }
}



void main(int argc, char **argv)
//================================================
//================================================
{
  int connect_appli_lia[2], 
    connect_lia_appli[2], 
    data_appli_lia[2], 
    data_lia_appli[2], 
    disconnect_appli_lia[2], 
    disconnect_lia_appli[2]; 

  Liaison_c *liaison; 
  
  if(argc!=2)
    {printf("Usage : emetteur FichAEmettre \n");
    exit(1);}
  
  //--------------- ouverture des tubes ----------------
		      
  if(pipe(connect_appli_lia)==-1)
    perror("connect_appli_lia");
  
  if(pipe(connect_lia_appli)==-1)
    perror("connect_lia_appli");
  
  if(pipe(data_appli_lia)==-1)
    perror("data_appli_lia");
  
  if(pipe(data_lia_appli)==-1)
    perror("data_lia_appli");
  
  if(pipe(disconnect_appli_lia)==-1)
    perror("disconnect_appli_lia");
  
  if(pipe(disconnect_lia_appli)==-1)
    perror("disconnect_lia_appli");
  

//--------------- separation appli-liaison ----------------

  liaison = new Liaison_c(connect_appli_lia, connect_lia_appli, 
			  data_appli_lia, data_lia_appli, 
			  disconnect_appli_lia, disconnect_lia_appli);
  switch(fork())
    {
    case (pid_t) -1 : perror("fork"); exit(2); 
    case (pid_t) 0  : /* processus liaison */
	
      liaison->Start();
	
    default :  /* processus application */
	
      Application(argv[1], liaison);
    }
}
