
//================================================
//
//	Samedi 21 novembre 1998
//
//	Arash HABIBI
//
//	Reception.C
//
//	Se contente de lancer application et liaison
//	reserve des tubes pour la communication 
//	entre les couches. Deux tubes pour chaque
//	service. 
//
//================================================


#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "Physique.H"

int connect_appli_phys[2], 
  connect_phys_appli[2], 
  data_appli_phys[2], 
  data_phys_appli[2], 
  disconnect_appli_phys[2], 
  disconnect_phys_appli[2]; 

CouchePhys_c *medium;


boolean ReceiveData(int SaveFile)
//================================================
//================================================
{
  char paquet[TAILLE_PAQUET];
  int taille, res; 

  if((taille = read(data_phys_appli[0], paquet, TAILLE_PAQUET))<=0)
    {perror("ReceiveData : read"); exit(1);}

  if((res = write(SaveFile, paquet, taille))<=0)
    {perror("Application : write"); exit(1);}
}


void Application(char *FileName, CouchePhys_c *medium)
//================================================
//================================================
{
  mode_t mode; 
  fd_set lecture, ecriture, except;
  int SaveFile, nbfds, nb_events, stop=0; 

  mode = S_IRUSR|S_IWUSR; 

  if((SaveFile=open(FileName, O_WRONLY|O_CREAT|O_TRUNC, mode))==-1)
    {perror(FileName); exit(1);}

  if(disconnect_phys_appli[0] > data_phys_appli[0]) 
    nbfds=disconnect_phys_appli[0]+1;
  else
    nbfds=data_phys_appli[0]+1;

  while(!stop)
    {
      //---- Preparation des ensembles -------- 
      //--------- de descripteurs ------------- 
      
      FD_ZERO(&lecture); 
      FD_ZERO(&ecriture); 
      FD_ZERO(&except); 
      FD_SET(disconnect_phys_appli[0],&lecture); 
      FD_SET(data_phys_appli[0],      &lecture); 
      
      //------- attente d'un evenment --------- 
      
      nb_events = select (nbfds, &lecture, &ecriture, 
			  &except, NULL);
      if(nb_events==-1) {perror("select"); exit(1);} 
      
      //------- le depouillement des votes ---- 
      
      if(FD_ISSET(data_phys_appli[0], &lecture))
	ReceiveData(SaveFile);

      else if(FD_ISSET(disconnect_phys_appli[0], &lecture))
	stop=VRAI;       
    }
  close(SaveFile);
}




void main(int argc, char **argv)
//================================================
//================================================
{ 
  if(argc!=2)
    {printf("Usage : emetteur FichAEmettre \n");
    exit(1);}
  
  //--------------- ouverture des tubes ----------------
		      
  if(pipe(connect_appli_phys)==-1)
    perror("connect_appli_phys");
  
  if(pipe(connect_phys_appli)==-1)
    perror("connect_phys_appli");
  
  if(pipe(data_appli_phys)==-1)
    perror("data_appli_phys");
  
  if(pipe(data_phys_appli)==-1)
    perror("data_phys_appli");
  
  if(pipe(disconnect_appli_phys)==-1)
    perror("disconnect_appli_phys");
  
  if(pipe(disconnect_phys_appli)==-1)
    perror("disconnect_phys_appli");
  


//--------------- separation appli-phys ----------------

  switch(fork())
    {
    case (pid_t) -1 : perror("fork"); exit(2); 
    case (pid_t) 0  : /* processus liaison */
	
      medium = new CouchePhys_c("sock_rec", "s_medrec", 
				data_phys_appli[1], data_appli_phys[0], 
				disconnect_phys_appli[1], disconnect_appli_phys[0]);
      delete medium; break;
	
    default :  /* processus application */
	
      Application(argv[1], medium);
    }
}
