
/*================================================*\

	Samedi 21 novembre 1998

	Arash HABIBI

	Reception.C

	Se contente de lancer application et liaison
	reserve des tubes pour la communication 
	entre les couches. Deux tubes pour chaque
	service. 

\*================================================*/


#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "Physique.h"

int connect_appli_phys[2], 
  connect_phys_appli[2], 
  data_appli_phys[2], 
  data_phys_appli[2], 
  disconnect_appli_phys[2], 
  disconnect_phys_appli[2]; 


boolean ReceiveData(int SaveFile)
/*================================================*\
\*================================================*/
{
  char paquet[TAILLE_PAQUET];
  int taille, res; 

  if((taille = read(data_phys_appli[0], paquet, TAILLE_PAQUET))<=0)
    {perror("ReceiveData : read"); exit(1);}

  if((res = write(SaveFile, paquet, taille))<=0)
    {perror("Application : write"); exit(1);}
}


void Application(char *FileName, CouchePhys_t *CchPhys)
/*================================================*\
\*================================================*/
{
  mode_t mode; 
  int res_select, autres_res, SaveFile;
  boolean stop=FAUX, crash=FAUX;

  /*----------- ouverture du fichier en ecriture ----------*/

  mode = S_IRUSR|S_IWUSR; 

  if((SaveFile=open(FileName, O_WRONLY|O_CREAT|O_TRUNC, mode))==-1)
    {perror(FileName); exit(1);}

  /*----------- attente d'un evenement ---------------------*/

  while((!stop)&&(!crash))
    {
      res_select = select4(data_phys_appli[0], 
			   -1, -1, 
			   disconnect_phys_appli[0], 
			   0.0);

      if(res_select==-1) crash = VRAI; 
      else
	{
	  if(res_select==1)
	    ReceiveData(SaveFile);
	  
	  else if(res_select==8)
	    stop=VRAI;       
	  
	  else
	    printf("rec : probeleme res_select = %d\n", res_select);
	}
    }
  close(SaveFile);
}




void main(int argc, char **argv)
/*================================================*\
\*================================================*/
{ 
  CouchePhys_t CchPhys;

  if(argc!=2)
    {printf("Usage : emetteur FichAEmettre \n");
    exit(1);}
  
  /*--------------- ouverture des tubes ----------------*/
		      
  if(pipe(connect_appli_phys)==-1)
    perror("connect_appli_phys");
  
  if(pipe(connect_phys_appli)==-1)
    perror("connect_phys_appli");
  
  if(pipe(data_appli_phys)==-1)
    perror("data_appli_phys");
  
  if(pipe(data_phys_appli)==-1)
    perror("data_phys_appli");
  
  if(pipe(disconnect_appli_phys)==-1)
    perror("disconnect_appli_phys");
  
  if(pipe(disconnect_phys_appli)==-1)
    perror("disconnect_phys_appli");
  


    /*--------------- separation appli-phys ----------------*/

  switch(fork())
    {
    case (pid_t) -1 : perror("fork"); exit(2); 
    case (pid_t) 0  : /* processus liaison */

      InitCouchePhys(&CchPhys, "sock_rec", "s_medrec", 
				data_phys_appli[1], data_appli_phys[0], 
				disconnect_phys_appli[1], disconnect_appli_phys[0]);
      FreeCouchePhys(&CchPhys); break;
	
    default :  /* processus application */
	
      Application(argv[1], &CchPhys);
    }
}
