/*==================================================*\

  Lundi 10 Aout 1998  

  Arash Habibi

  Timer.C

  Inspire de Timer.c

\*==================================================*/


#include "Timer.H"

Timer_c *T;			// magouille pour le handler

Timer_c::Timer_c()
//====================================================
//====================================================
{
    timer.it_interval.tv_sec =  2; 
    timer.it_interval.tv_usec = 0;

    timer.it_value.tv_sec = 0; 
    timer.it_value.tv_usec = 1; 

    _expired = FAUX; 

    p_action2.sa_handler = &Reponse2; 

    sigaction(SIGALRM, &p_action2, &p_action2_anc); 

    sigemptyset(&_demasque); 
    sigemptyset(&_masque); 
    sigaddset(&_masque, SIGALRM); 

    // masquons les signaux tant que le 
    // film n'est pas encore commence. 

    sigprocmask(SIG_SETMASK, &_masque, NULL); 

    // Apres setitimer, les signaux d'horloge vont 
    // pleuvoir. Heureusement qu'il y a le masque. 

    setitimer(ITIMER_REAL, &_timer, &_old_timer); 

    T = this; 
}


Timer_c::~Timer_c()
//====================================================
//====================================================
{
    ;
}


 
void Timer_c::Start(long deltaT)
//====================================================
// Arme le timeout. Attend deltaT. 
//====================================================
{
    _expired = FAUX; 
  
    _timer.it_interval.tv_sec = 0; 
    _timer.it_interval.tv_usec = _deltaT;

    _timer.it_value.tv_sec = 0; 
    _timer.it_value.tv_usec = 1; 

    setitimer(ITIMER_REAL, &timer, &old_timer); 
    sigprocmask(SIG_SETMASK, &_demasque, NULL); 
    pause();
}


 
void Timer_c::Stop()
//====================================================
// Desarme le timeout. 
//====================================================
{
    sigprocmask(SIG_SETMASK, &_masque, NULL); 
}


boolean Timer_c::Expired()
//====================================================
// Desarme le timeout. 
//====================================================
{
  return(_expired);
}


void Timer_c::_Handler()
//====================================================
//====================================================
{
  static int nb_calls=0; 

  if(nb_calls==1)
    _expired=VRAI; 

  nb_calls = (nb_calls + 1) % 2; 
}
