
/*================================================*\

	Samedi 21 novembre 1998

	Arash HABIBI

	main.c

	Se contente de lancer application et liaison
	reserve des tubes pour la communication 
	entre les couches. Deux tubes pour chaque
	service. 

\*================================================*/


#include <stdio.h>
#include <string.h>
#include <unistd.h>


#include "Physique.h"
#include "Application.h"

int connect_appli_phys[2], 
  connect_phys_appli[2], 
  data_appli_phys[2], 
  data_phys_appli[2], 
  disconnect_appli_phys[2], 
  disconnect_phys_appli[2]; 


void main(int argc, char **argv)
/*================================================*\
\*================================================*/
{ 
  CouchePhys_t  CchPhys;
  CoucheAppli_t CchAppli;

  if((argc!=2)||((atoi(argv[1])!=1)&&(atoi(argv[1])!=2)))
    {printf("Usage : station indice\navec indice=1 ou indice=2\n");
    exit(1);}
  
  /*--------------- ouverture des tubes ----------------*/
		      
  if(pipe(connect_appli_phys)==-1)
    perror("connect_appli_phys");
  
  if(pipe(connect_phys_appli)==-1)
    perror("connect_phys_appli");
  
  if(pipe(data_appli_phys)==-1)
    perror("data_appli_phys");
  
  if(pipe(data_phys_appli)==-1)
    perror("data_phys_appli");
  
  if(pipe(disconnect_appli_phys)==-1)
    perror("disconnect_appli_phys");
  
  if(pipe(disconnect_phys_appli)==-1)
    perror("disconnect_phys_appli");
  

  /*--------------- Separation appli-phys ----------------*/

  switch(fork())
    {
    case (pid_t) -1 : perror("fork"); exit(2); 

      /*-------------- processus couche physique -------------------- */

    case (pid_t) 0  :		/* fils */

      InitCouchePhys(&CchPhys, atoi(argv[1]), 
		     data_phys_appli[1], data_appli_phys[0], 
		     disconnect_phys_appli[1], disconnect_appli_phys[0]);

      /*-------------- processus couche application ------------------*/

    default :			/* pere */
	
      InitCoucheAppli(&CchAppli, atoi(argv[1]), 
		      data_phys_appli[0], data_appli_phys[1], 
		      disconnect_phys_appli[0], disconnect_appli_phys[1]);
    }
}
