
/*================================================*\

	Lundi 23 novembre 1998

	Arash HABIBI

	Physique.h

        Tout ce qui concerne la couche physique

\*================================================*/


#ifndef _PHYS_H
#define _PHYS_H

#include "define.h"
#include "Toolbox.h"
#include "Attente.h"

#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>

typedef struct CouchePhys_t
{				/* les descripteurs de tubes */
  int				/* representant les SAP      */
    Data_PL,			/* Data Physique a Liaion    */
    Data_LP,			/* Data Liaison a Physique   */
    Disc_PL,			/* Deconnexion Phys a Lia    */
    Disc_LP;			/* Deconnexion Lia a Phys    */
    
  int identite;			/* identite : 0 ou 1 selon qu'on est  */
				/* station1 ou station2  */
  int desc_sock;		/* descripteur de la socket  */
  struct sockaddr_un adresse_loc;
  struct sockaddr_un adresse_dist;

} CouchePhys_t;

extern void InitCouchePhys(CouchePhys_t *CchPhys, int id, int data_pl, int data_lp, int disc_pl, int disc_lp);
extern void FreeCouchePhys(CouchePhys_t *CchPhys); 

void SetLocAdrSock(char *ref, CouchePhys_t *);
void SetDstAdrSock(char *ref, CouchePhys_t *);

void Phys_ViderTubeInterface(int tube);
void Phys_DisconnectIndication(int Disc_PL, int Disc_LP);
int  Phys_DisconnectRequest(int desc_sock, struct sockaddr_un adr_dist);
int  Phys_SendData(int desc_sock, struct sockaddr_un adr_dist, int Data_LP);
int  Phys_ReceiveData(int desc_sock, struct sockaddr_un adr_dist, int Data_PL);

void Phys_Boucle(CouchePhys_t *CchPhys);

#endif
