
/*================================================*\

	Dimanche 29 novembre 1998

	Arash HABIBI

	Liaison.c

	Tout ce qui concerne la couche liaison. 

\*================================================*/


#include "Liaison.h"

void InitCoucheLia(CoucheLia_t *CchLia, int id, int conn_la, int conn_al, int data_la, int data_al, int disc_la, int disc_al, int data_lp, int data_pl, int disc_lp, int disc_pl)
/*================================================*\
\*================================================*/
{
  fprintf(stderr, "Couche Liaison %d : commence.\n", id);

  CchLia->Conn_AL =  conn_al;
  CchLia->Conn_LA =  conn_la;
  CchLia->Data_AL =  data_al; 
  CchLia->Data_LA =  data_la; 
  CchLia->Disc_AL =  disc_al;
  CchLia->Disc_LA =  disc_la;

  CchLia->Data_PL =  data_pl; 
  CchLia->Data_LP =  data_lp; 
  CchLia->Disc_PL =  disc_pl;
  CchLia->Disc_LP =  disc_lp;

  CchLia->identite = id; 

  Lia_Boucle(CchLia);
}


void FreeCoucheLia(CoucheLia_t *CchLia)
/*================================================*\
  Ferme les tubes; 
\*================================================*/
{
  close(CchLia->Conn_AL);
  close(CchLia->Conn_LA);
  close(CchLia->Conn_LA);
  close(CchLia->Data_AL);
  close(CchLia->Data_LA);
  close(CchLia->Disc_AL);
  close(CchLia->Disc_LA); 

  close(CchLia->Data_AL);
  close(CchLia->Data_LA);
  close(CchLia->Disc_AL);
  close(CchLia->Disc_LA); 
}


void Lia_ViderTubeInterface(int tube)
/*================================================*\
  Certains tubes n'ont pas besoin d'etre vraiment
  "lues" car leur contenu n'a pas beaucoup 
  d'importance. C'est le fait qu'il y ait un 
  message qui est important. C'est tout ce qui est 
  tube d'interface (disc, conn etc). Or si on ne 
  les lit pas, il faut tout de meme les vider, 
  sinon, la prochaine fois qu'on lira dessus, 
  les anciennes donnees y seront toujours. 
\*================================================*/
{
  char message[TAILLE_ASPI];

  if(read(tube, message, TAILLE_ASPI)<=0)
    {perror("Appli_ViderTubeInterface read"); exit(1);}
}

int Lia_ExtrairePaquet(int Data_PL, int Data_LA)
/*================================================*\
  Lire la trame, extraire le paquet de la trame et 
  l'envoyer a la couche application. 
\*================================================*/
{
  int taille_lu, taille_ecrit; 
  Paquet_t paquet[1]; 
  Trame_t  trame [1];

  taille_lu = read(Data_PL, trame, TAILLE_TRAME);

  if(taille_lu==-1)
    {perror("Lia_ExtrairePaquet read"); return(-1);}
  
  else 
    {
      paquet[0] = (trame[0])%256; 

      taille_ecrit = write(Data_LA, paquet, TAILLE_PAQUET);

      if(taille_ecrit==-1)
	{perror("Lia_ExtrairePaquet write"); return(-1);}
      else
	return(1);
    }
}



int Lia_EncapsulerPaquet(int Data_AL, int Data_LP)
/*================================================*\
  Lire le paquet, le mettre sur une trame et 
  l'envoyer a la couche physique. 
\*================================================*/
{
  int taille_lu, taille_ecrit; 
  Paquet_t paquet[1]; 
  Trame_t  trame [1];

  taille_lu = read(Data_AL, paquet, TAILLE_PAQUET);

  if(taille_lu==-1)
    {perror("Lia_EncapsulerPaquet read"); return(-1);}
  
  else 
    {
      trame[0] = paquet[0]; 

      taille_ecrit = write(Data_LP, trame, TAILLE_TRAME);

      if(taille_ecrit==-1)
	{perror("Lia_EncapsulerPaquet write"); return(-1);}
      else
	return(1);
    }
}


void Lia_DisconnectRequest(int Disc_LP)
/*================================================*\
  Demande a la couche physique de se debrancher. 
\*================================================*/
{
  write(Disc_LP, REQUEST, 1);
}


void Lia_Boucle(CoucheLia_t *CchLia)
/*================================================*\
  Une seule boucle dans laquelle on attend 
  simplement des donnees venant de la couche 
  appli, qu'on transmet a la couche physique 
  ou alors des donnees venant de la couche 
  physique qu'on transfere a la couche 
  application. 
  La boucle prend fin lorsque la couche appli
  a demande une deconnexion et que pendant 
  plus de 3 secondes, on ne recoit rien de
  la couche physique. 
\*================================================*/
{
  int res_attente, res; 
  boolean crash=FAUX, stop=FAUX;
  boolean DeconnexionDemandee=FAUX; 

  while((crash==FAUX)&&(stop==FAUX))
    {
      res_attente = Attendre(CchLia->Data_AL,
			     CchLia->Data_PL,
			     RIEN, 
			     CchLia->Disc_AL,
			     3.0);

      if(res_attente==-1) crash = VRAI; 
      else
	{
	  if((res_attente==TIMEOUT)&&(DeconnexionDemandee))
	    {printf("timeout.\n");
	    stop=VRAI;}
	    
	  /*-------- un paquet venant de la couche reseau ------*/

	  if(((res_attente==YaALireSur1___)||(res_attente==YaALireSur12__))||
	     ((res_attente==YaALireSur1_3_)||(res_attente==YaALireSur123_)))
	    {
	      res = Lia_EncapsulerPaquet(CchLia->Data_AL, CchLia->Data_LP);

	      if(res<0) crash=VRAI;
	      else /* tout va bien */;
	    }

	  /*-------- une donnee venant de la couche physique-------*/

	  if(((res_attente==YaALireSur_2__)||(res_attente==YaALireSur12__))||
	     ((res_attente==YaALireSur_23_)||(res_attente==YaALireSur123_)))
	    {
	      res = Lia_ExtrairePaquet(CchLia->Data_PL, CchLia->Data_LA);

	      if(res<0) crash=VRAI;
	      else /* tout va bien */;
	    }

	  /*-------- une demande de deconnexion de la couche appli ----*/

	  if(res_attente==YaALireSur___4)
	    {
	      DeconnexionDemandee=VRAI;
	      printf("======>>>>>>>Liaison : DeconnexionDemandee.\n");
	      printf("======>>>>>>>Liaison : DeconnexionDemandee.\n");
	      Lia_ViderTubeInterface(CchLia->Disc_LA); 
	    }
	}
    }
  Lia_DisconnectRequest(CchLia->Disc_LP);
  FreeCoucheLia(CchLia);
  fprintf(stderr, "Couche Liaison : deconnectee.\n", CchLia->identite);
}



