
/*===============================================*\
	Mardi 3 novembre 1998

	Arash HABIBI

	Logic.c

	Quelques fonctions logiques comme les 
	ou exclusifs. 

\*================================================*/


#include "Logic.h"



char NiemeBit(int nombre, int n)
/*================================================*\
  Rend le n-ieme bit du nombre "nombre". 
  On commence avec le bit 1 pour les unites et on 
  finit avec le bit 8 pour 128, etc. 
\*================================================*/
{
  return((nombre & (1<<(n-1)))>>(n-1)); 
}


void CheckBitABit(short sh, char *comment)
/*===============================================*\
  Affiche chaque bit de car. 
\*===============================================*/
{
  printf("%s : %u : %d%d%d%d%d%d%d%d%d%d%d%d%d%d%d%d\n", 
	 comment,
	 sh, 
	 NiemeBit(sh, 16), 
	 NiemeBit(sh, 15), 
	 NiemeBit(sh, 14), 
	 NiemeBit(sh, 13),
	 NiemeBit(sh, 12), 
	 NiemeBit(sh, 11), 
	 NiemeBit(sh, 10), 
	 NiemeBit(sh, 9), 
	 NiemeBit(sh, 8), 
	 NiemeBit(sh, 7), 
	 NiemeBit(sh, 6), 
	 NiemeBit(sh, 5), 
	 NiemeBit(sh, 4), 
	 NiemeBit(sh, 3), 
	 NiemeBit(sh, 2), 
	 NiemeBit(sh, 1));
}


void SetNiemeBitCC(CarCode_t *nombre, int n, int value)
/*================================================*\
  Change le n-ieme bit pour le mettre a value
  (On commence avec le bit 1 pour les unites et 
  le bit 8 pour 128 etc. 
\*================================================*/
{
  if(value)
    *nombre = *nombre | (1<<(n-1)) ;
  else
    *nombre = *nombre & (~(1<<(n-1))) ;
}


void SetNiemeBitC(char *nombre, int n, int value)
/*================================================*\
  Change le n-ieme bit pour le mettre a value
  (On commence avec le bit 1 pour les unites et 
  le bit 8 pour 128 etc. 
\*================================================*/
{
  if(value)
    *nombre = *nombre | (1<<(n-1)) ;
  else
    *nombre = *nombre & (~(1<<(n-1))) ;
}


CarCode_t OuExclusif(CarCode_t a, CarCode_t b)
/*================================================*\
\*================================================*/
{
	return(a^b);
}



void ChangeNiemeBitCC(CarCode_t *cc, int n)
/*===============================================*\
  Change la valeur du n-ieme bit de cc 0<->1.
\*===============================================*/
{
  *cc = OuExclusif(*cc, 1<<(n-1));
}


void ChangeNiemeBitC(char *car, int n)
/*===============================================*\
  Change la valeur du n-ieme bit de car 0<->1.
\*===============================================*/
{
  *car = OuExclusif(*car, 1<<(n-1));
}


void TronquerANbits(CarCode_t *cc, int N)
/*===============================================*\
  Annule les bits de poids N+1, N+2, ... qui 
  peuvent perturber les calculs quand il faut 
  regarder le degre des polynomes ou alors voir 
  si le reste est nul. 
\*===============================================*/
{
  int i; 
  
  for(i=8*sizeof(CarCode_t); i>N; i--)
  	SetNiemeBitCC(cc, i, 0);
}


int Degre(CarCode_t cc)
/*===============================================*\
  cc represente un polynome de degre au plus max. 
  Par exemple 10011. Degre donne le degre de ce 
  polynome (en l'occurrence 4)
\*===============================================*/
{
  int i, trouve=0; 

  i=8*sizeof(CarCode_t); 

  if(cc==0) return(0); 
  else
    while(NiemeBit(cc, i)==0)
      i--; 

  return(i-1); 
}


