
/*===============================================*\
	Mercredi 9 Septembre 1998

	Arash HABIBI

	Ouvre9Sockets.c

	Un programme qui ouvre 9 sockets differentes. 
	La cause de l'echec de l'ouverture d'une 
	socket est donnee, le cas echeant par la 
	fonction perror. 
	
\*================================================*/


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>


void main()
{
	/* ---- Ouverture d'une socket unix de type stream protocole TCP --- */
	
	if(socket(AF_UNIX, SOCK_STREAM, IPPROTO_TCP)==-1)
		perror("[SOCK_STREAM, AF_UNIX, IPPROTO_TCP]"); 
	else
		printf("socket [SOCK_STREAM, AF_UNIX, IPPROTO_TCP] creee.\n");
		

	/* ---  Une socket unix de type datagramme protocole UDP --- */
	
	if(socket(AF_UNIX, SOCK_DGRAM, IPPROTO_UDP)==-1)
		perror("[SOCK_DGRAM, AF_UNIX, IPPROTO_UDP]"); 
	else
		printf("socket [SOCK_DGRAM, AF_UNIX, IPPROTO_UDP] creee.\n");
		

	/* ---  Une socket unix de type datagramme protocole par defaut --- */
	
	if(socket(AF_UNIX, SOCK_DGRAM, 0)==-1)
		perror("[SOCK_DGRAM, AF_UNIX, defaut]"); 
	else
		printf("[SOCK_DGRAM, AF_UNIX, defaut] creee.\n");
		
		
	/* ---  Une socket unix de type stream protocole par defaut  --- */
	
	if(socket(AF_UNIX, SOCK_STREAM, 0)==-1)
		perror("[SOCK_STREAM, AF_UNIX, defaut]"); 
	else
		printf("[SOCK_STREAM, AF_UNIX, defaut] creee.\n");
		
		
	/* ---  Une socket internet de type datagramme protocole UDP --- */
	
	if(socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)==-1)
		perror("[SOCK_DGRAM, AF_INET, IPPROTO_UDP]"); 
	else
		printf("[SOCK_DGRAM, AF_INET, IPPROTO_UDP] creee.\n");
		
					
	/* ---  Une socket internet de type stream protocole TCP  --- */
	
	if(socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)==-1)
		perror("[SOCK_STREAM, AF_INET, IPPROTO_TCP]"); 
	else
		printf("[SOCK_STREAM, AF_INET, IPPROTO_TCP] creee.\n");
				
	
	/* ---  Une socket internet de type datagramme protocole TCP  --- */
	
	if(socket(AF_INET, SOCK_DGRAM, IPPROTO_TCP)==-1)
		perror("[SOCK_DGRAM, AF_INET, IPPROTO_TCP]"); 
	else
		printf("socket [SOCK_DGRAM, AF_INET, IPPROTO_TCP] creee.\n");
		

	/* ---  Une socket internet de type stream protocole UDP  --- */
	
	if(socket(AF_INET, SOCK_STREAM, IPPROTO_UDP)==-1)
		perror("[SOCK_STREAM, AF_INET, IPPROTO_UDP]"); 
	else
		printf("[SOCK_STREAM, AF_INET, IPPROTO_UDP] creee.\n");
				

	/* ---  Une socket internet reduite aux paquets IP protocole IP --- */
	
	if(socket(AF_INET, SOCK_RAW, IPPROTO_IP)==-1)
		perror("[SOCK_RAW, AF_INET, IPPROTO_IP]"); 
	else
		printf("socket [SOCK_RAW, AF_INET, IPPROTO_IP] creee.\n");
}	
