
/*===============================================*\
	Vendredi 18 Septembre 1998

	Arash HABIBI

	ClientTCP.c

	Un espece de talk simplifie. 
	Ce cote-ci joue le role de client, 
	simplement dans le sens ou c'est lui 
	qui demande la connexion a l'autre cote.         
	L'interet de la manip est de montrer 
	le maniement des primitives en mode
	non-bloquant. 

\*================================================*/

#define OK 1

#include <errno.h>

#include "SocketToolbox.h"


int ConnexionClient(char *HostName, short port_dist, short port_loc)
/*===============================================*\
\*===============================================*/
{
	struct sockaddr_in adresse_loc, adresse_dist;
	int desc_sock, res, taille_adr, nb_pendants=1;  
	
/*-------- Creation et attachement de la socket du client -----*/
	
	desc_sock = GetAndBindSocket(SOCK_STREAM, port_loc, 
		&adresse_loc);
	
	printf("Client TCP sur port numero %d\n",
		adresse_loc.sin_port);
		
		
/*-------- Preparation de l'adresse distante et connexion ------*/
			
	adresse_dist = WriteNetworkAddress(HostName, port_dist); 
	res = connect(desc_sock, (struct sockaddr*) &adresse_dist, 
		sizeof(adresse_dist));
	
	if(res == -1) {perror("connect"); exit(1);}
	else printf("Client TCP connecte.\n");

	return(desc_sock);
}



int GaverSocket(int desc_sock, char *message, int taille)
/*===============================================*\
  En mode non-bloquant, lorsqu'on ecrit dans une
  socket, tout n'est pas necessairement 
  transmis. Ce qui peut etre transmis est 
  transmis et le reste est ignore. Donc c'est
  nous qui devons tenir compte de cette partie 
  ignoree et la reexpedier des que possible. 
  Cette fonction rend 1 si le message courant 
  a ete transmis et qu'on peut aller chercher 
  un autre message. 
\*===============================================*/
{
    static int index=0; 
    static int transmis=0; 
    int res; 
    char *buffer;		/* la partie non-transmise */ 
				/* du message              */
    if(index==0) transmis=0; 
    
    buffer = message+index; 

    res = write(desc_sock, buffer, taille-index);
    if((res==-1)&&(errno!=EWOULDBLOCK))  
	{perror("GaverSocket"); return(-1);}

    /* else if ((res==-1)&&(errno==EWOULDBLOCK)); */
    /* --------- il ne se passe rien ------------ */

    else if(res==0) return(-1); /* socket paire fermee */

    else if(res>0) 
	{
	    index += res; 
	    if(index==taille)
		{   index=0;  transmis=1; }
	}
    return(transmis); 
}
       
    
void main(int argc, char **argv)
/*===============================================*\
\*===============================================*/
{
	int term_rec, term_send, desc_sock;
	int transmission_over, crash, nonbloquant; 
	int nb_lu, nb_recu, res, msg_prcdt_transmis=OK; 
	char message[100];
	 
	if(argc!=4) 
	{printf("Usage : PapotClient <hote> <port_num> <NomTerminal>\n\n"); 
	exit(1);}	

/*-------- Ouvertures diverses -------- ------------------*/

	/*-- Le terminal sur lequel on enverra -------*/

	term_send = open("/dev/tty", O_RDWR); 
	if(term_send == -1) 
	    {perror("terminal de controle"); exit(1);}

	/*-- Le terminal sur lequel on recevra -------*/

	term_rec = open(argv[3], O_RDWR); 
	if(term_rec == -1) 
	    {perror("terminal de lecture"); exit(1);}

/*-------- Connexion ------------------ ------------------*/
	
	desc_sock = ConnexionClient(argv[1], atoi(argv[2]), 0);
	transmission_over = 0; crash = 0; 
	
/*-------- Passage en mode non-bloquant ------------------*/

	nonbloquant=1; 
	ioctl(desc_sock, FIONBIO, &nonbloquant);

	nonbloquant=1; 
	ioctl(term_send, FIONBIO, &nonbloquant);
	      
/*-------- La boucle d'attente d'evenement ---------------*/

	while((!crash)&&(!transmission_over))
	{
	    /*-------------- lecture de la socket --------*/

		nb_recu = read(desc_sock, message, 10);

		if((nb_recu==-1)&&(errno!=EWOULDBLOCK)) 
		    {perror("read socket"); crash=1;}

		else if((nb_recu==-1)&&(errno==EWOULDBLOCK)) 
		    /* silence radio rien a faire */;

		else if(nb_recu==0) /* socket paire fermee */
		    crash=1; 

		else if((nb_recu==2)&&
			(strncmp(message, ".", nb_recu-1)==0))
		    transmission_over=1; 

		else if(nb_recu>0)
		    {
			/*----- ecriture terminal ------- */

			res=write(term_rec, message, nb_recu);
			/* celui-ci est reste bloquant */
			if(res==-1) perror("write terminal");
		    }

		/*-------------- lecture du terminal -----*/

		if(msg_prcdt_transmis==OK)
		    nb_lu = read(term_send, message, 10);

		if((nb_lu==-1)&&(errno!=EWOULDBLOCK))
		    {perror("read terminal de ctrl"); crash=1;}
		    
		else if((nb_lu==-1)&&(errno==EWOULDBLOCK));
 			/* Rien a lire, c'est tout */
			
		else if(nb_lu>0)
		    {
			/*----- envoi sur socket ---------*/

			/*res=write(desc_sock, message, nb_lu);*/
			msg_prcdt_transmis=
			    GaverSocket(desc_sock, message, nb_lu); 

			if(msg_prcdt_transmis==-1)
			    crash=1; 

			else if(msg_prcdt_transmis==OK)
			    if((nb_lu==2)&&
			    	(strncmp(message, ".", nb_lu-1)==0))
				transmission_over=1; 
			    else;
				/* tout va bien on  */
				/* passe a la suite */
		    }
	}

	close(desc_sock);
	if(crash)
		printf("Echange interrompu\n\n");
	else if(transmission_over)
		printf("Echange termine. Deconnexion.\n\n");
}
